#include <vector>
#include <map>

namespace aslConversion
{
    #define SETUP_CLASS_REFERENCE_TRACKING(x) \
                std::map<referenceTracker<void*>, referenceTracker<void*> > x::objectList;

    template <class type>
    class referenceTracker
    {
       public:

        static std::map< void* , void* > objectList;

        void deleteObject (void* object )
        {
            objectList.erase(object);
        }

        void trackObject (void* object )
        {
            objectList[object] = object;
        }

        int referenceCount()
        {
            return objectList.size();
        }
        
       protected:
        referenceTracker()
        {
            trackObject(this);
        }

        virtual ~referenceTracker()
        {
            deleteObject(this);
        }
       public:
        // Get a vector of the objects instantiated.
        //  const - so you's can't mess wit em.
        const std::vector<void*>* getObjList()
        {
            return &objectList;
        }

    };
    
};
